//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "testapp.h"
#include "plotstyle.h"
#include <math.h>
#include "PlotForm.h"
#include "about.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
   G1Index = 1;
   G2Index = 2;
   G3Index = 3;
   G4Index = 4;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
   int i;
   double ar[30];

   for(i=0;i<30;i++)
      ar[i] = 2*(sin(double(i+1)/3.0))/(double(i+1)/3.0);
   Form2->Show();
   Form2->XYPlot1->XYPlot(ar,30,G1Index);
   Style1->Enabled = true;
   PlotColor1->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Axis1Click(TObject *Sender)
{
   if(ColorDialog1->Execute())
   {
      Form2->XYPlot1->AxisColor = ColorDialog1->Color;
   }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::PlotColor2Click(TObject *Sender)
{
   if(ColorDialog1->Execute())
   {
      if (Sender == PlotColor1)
         Form2->XYPlot1->SetPlotColor(ColorDialog1->Color,G1Index);
      else if (Sender == PlotColor2)
         Form2->XYPlot1->SetPlotColor(ColorDialog1->Color,G2Index);
      else if (Sender == PlotColor3)
         Form2->XYPlot1->SetPlotColor(ColorDialog1->Color,G3Index);
      else if (Sender == PlotColor4)
         Form2->XYPlot1->SetPlotColor(ColorDialog1->Color,G4Index);
   }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{
   int i;
   double ar[50];

   for(i=0;i<50;i++)
      ar[i] = exp(-double(i+1)/5);
   Form2->XYPlot1->XYPlot(ar,50,1,10,G2Index, clGreen, FilledPoints);
   Form2->Show();
   Style2->Enabled = true;
   PlotColor2->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ScrollBar1Change(TObject *Sender)
{
   Form2->XYPlot1->YMax = ScrollBar1->Position;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button4Click(TObject *Sender)
{
   int i;
   double ar[50];

   for(i=0;i<50;i++)
      ar[i] = sin(double(i)/5)/2;
   Form2->XYPlot1->XYPlot(ar,50,-1,1,G3Index, clBlue, LinesOpenPoints);
   Style3->Enabled = true;
   PlotColor3->Enabled = true;
   Form2->Show();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button5Click(TObject *Sender)
{
   int i;
   double xar[350], yar[350];
   double r, theta;

   for(i=0;i<350;i++)
   {
      theta = i/25.0;
      r = cos(theta)*sin(2.5*theta);
      xar[i] = r * cos(theta);
      yar[i] = r*sin(theta);
   }
   Form2->XYPlot1->XYPlot(xar,yar,350,G4Index, clYellow);
   Form2->Show();
   Style4->Enabled = true;
   PlotColor4->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CheckBox2Click(TObject *Sender)
{
   Form2->XYPlot1->XAutoScale = CheckBox2->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ScrollBar3Change(TObject *Sender)
{
   Form2->XYPlot1->XMin = ScrollBar3->Position;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ScrollBar4Change(TObject *Sender)
{
   Form2->XYPlot1->XMax = ScrollBar4->Position;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CheckBox3Click(TObject *Sender)
{
   Form2->XYPlot1->ShowCoordinates = CheckBox3->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CenteredBoxButtonClick(TObject *Sender)
{
      if (BoxButton->Checked)
         Form2->XYPlot1->AxisStyle = Box;
      else if (CenteredBoxButton->Checked)
         Form2->XYPlot1->AxisStyle = CenteredBox;
      else if (LBButton->Checked)
         Form2->XYPlot1->AxisStyle = LB;
      else if (CenteredButton->Checked)
         Form2->XYPlot1->AxisStyle = Centered;
      else if (NoneButton->Checked)
         Form2->XYPlot1->AxisStyle = None;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CheckBox4Click(TObject *Sender)
{
   Form2->XYPlot1->ShowXLabel = CheckBox4->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CheckBox5Click(TObject *Sender)
{
   Form2->XYPlot1->ShowYLabel = CheckBox5->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button3Click(TObject *Sender)
{
   Form2->XYPlot1->RemovePlot(G1Index);
   Style1->Enabled = false;
   PlotColor1->Enabled = false;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button6Click(TObject *Sender)
{
   Form2->XYPlot1->RemovePlot(G2Index);
   Style2->Enabled = false;
   PlotColor2->Enabled = false;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button7Click(TObject *Sender)
{
   Form2->XYPlot1->RemovePlot(G3Index);
   Style3->Enabled = false;
   PlotColor3->Enabled = false;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button8Click(TObject *Sender)
{
   Form2->XYPlot1->RemovePlot(G4Index);
   Style4->Enabled = false;
   PlotColor4->Enabled = false;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ScrollBar5Change(TObject *Sender)
{
   Form2->XYPlot1->PointSize = ScrollBar5->Position;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Style1Click(TObject *Sender)
{
   TPlotStyle PStyle;
   bool PlotFound;

   if (Sender == Style1)
   {
      PlotFound = Form2->XYPlot1->GetPlotStyle(PStyle, G1Index);
      StyleDialog->Caption = "Plot 1 Style";
   }
   else if (Sender == Style2)
   {
      PlotFound = Form2->XYPlot1->GetPlotStyle(PStyle, G2Index);
      StyleDialog->Caption = "Plot 2 Style";
   }
   else if (Sender == Style3)
   {
      PlotFound = Form2->XYPlot1->GetPlotStyle(PStyle, G3Index);
      StyleDialog->Caption = "Plot 3 Style";
   }
   else if (Sender == Style4)
   {
      PlotFound = Form2->XYPlot1->GetPlotStyle(PStyle, G4Index);
      StyleDialog->Caption = "Plot 4 Style";
   }

   if (PlotFound)
   {
      switch(PStyle)
      {
         case Lines : StyleDialog->LineButton->Checked = true; break;
         case OpenPoints : StyleDialog->OpenPointButton->Checked = true; break;
         case FilledPoints : StyleDialog->FilledPointButton->Checked = true; break;
         case LinesOpenPoints : StyleDialog->LOPButton->Checked = true; break;
         case LinesFilledPoints : StyleDialog->LFPButton->Checked = true; break;
      }
      StyleDialog->PStyle = PStyle;
      if(StyleDialog->ShowModal() == 1)
      {
        if(Sender == Style1)
            Form2->XYPlot1->SetPlotStyle(StyleDialog->PStyle,G1Index);
         else if(Sender == Style2)
            Form2->XYPlot1->SetPlotStyle(StyleDialog->PStyle,G2Index);
         else if(Sender == Style3)
            Form2->XYPlot1->SetPlotStyle(StyleDialog->PStyle,G3Index);
         else if(Sender == Style4)
            Form2->XYPlot1->SetPlotStyle(StyleDialog->PStyle,G4Index);
      }
   }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CheckBox6Click(TObject *Sender)
{
   Form2->XYPlot1->MouseControl = CheckBox6->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Exit1Click(TObject *Sender)
{
Application->Terminate();	
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CheckBox7Click(TObject *Sender)
{
   Form2->XYPlot1->ShowHorzGrid = CheckBox7->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CheckBox8Click(TObject *Sender)
{
   Form2->XYPlot1->ShowVertGrid = CheckBox8->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ScrollBar6Change(TObject *Sender)
{
   Form2->XYPlot1->NumHorzGrid = ScrollBar6->Position;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ScrollBar7Change(TObject *Sender)
{
   Form2->XYPlot1->NumVertGrid = ScrollBar7->Position;

}
//---------------------------------------------------------------------------
void __fastcall TForm1::CheckBox1Click(TObject *Sender)
{
   Form2->XYPlot1->YAutoScale = CheckBox1->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ScrollBar2Change(TObject *Sender)
{
   Form2->XYPlot1->YMin = ScrollBar2->Position;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Grid1Click(TObject *Sender)
{
   if(ColorDialog1->Execute())
   {
      Form2->XYPlot1->GridColor = ColorDialog1->Color;
   }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::XLinearButtonClick(TObject *Sender)
{
   if (Sender==XLinearButton)
      Form2->XYPlot1->XAxisFormat = Linear;
   else if (Sender == XLogButton)
      Form2->XYPlot1->XAxisFormat = Log;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::YLinearButtonClick(TObject *Sender)
{
   if (Sender==YLinearButton)
      Form2->XYPlot1->YAxisFormat = Linear;
   else if (Sender == YLogButton)
      Form2->XYPlot1->YAxisFormat = Log;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::AutoRedrawBoxClick(TObject *Sender)
{
   Form2->XYPlot1->AutoRedraw = AutoRedrawBox->Checked;	
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button9Click(TObject *Sender)
{
   Form2->XYPlot1->Redraw();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::PlotTitleBoxClick(TObject *Sender)
{
  Form2->XYPlot1->ShowPlotTitle = PlotTitleBox->Checked;	
}
//---------------------------------------------------------------------------
void __fastcall TForm1::XTitleBoxClick(TObject *Sender)
{
   Form2->XYPlot1->ShowXTitle = XTitleBox->Checked;	
}
//---------------------------------------------------------------------------
void __fastcall TForm1::YTitleBoxClick(TObject *Sender)
{
   Form2->XYPlot1->ShowYTitle = YTitleBox->Checked;	
}
//---------------------------------------------------------------------------
void __fastcall TForm1::PlotTitle1Click(TObject *Sender)
{
   if (Sender== PlotTitle1)
      FontDialog1->Font->Assign(Form2->XYPlot1->PlotTitleFont);
   else if (Sender == AxisTitles1)
      FontDialog1->Font->Assign(Form2->XYPlot1->AxisTitleFont);
   else if (Sender == AxisLabels1)
      FontDialog1->Font->Assign(Form2->XYPlot1->AxisLabelFont);
   else if (Sender == MouseCoordinates1)
      FontDialog1->Font->Assign(Form2->XYPlot1->MouseCoordFont);
    if(FontDialog1->Execute())
   {
      if (Sender== PlotTitle1)
         Form2->XYPlot1->PlotTitleFont=FontDialog1->Font;
      else if (Sender == AxisTitles1)
         Form2->XYPlot1->AxisTitleFont=FontDialog1->Font;
      else if (Sender == AxisLabels1)
         Form2->XYPlot1->AxisLabelFont=FontDialog1->Font;
      else if (Sender == MouseCoordinates1)
         Form2->XYPlot1->MouseCoordFont=FontDialog1->Font;
   }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::HorzTickBoxClick(TObject *Sender)
{
   Form2->XYPlot1->ShowHorzTicks = HorzTickBox->Checked;	
}
//---------------------------------------------------------------------------
void __fastcall TForm1::VertTickBoxClick(TObject *Sender)
{
   Form2->XYPlot1->ShowVertTicks = VertTickBox->Checked;	
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ScrollBar8Change(TObject *Sender)
{
   Form2->XYPlot1->HorzTickLength = ScrollBar8->Position;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ScrollBar9Change(TObject *Sender)
{
   Form2->XYPlot1->VertTickLength = ScrollBar9->Position;	
}
//---------------------------------------------------------------------------
void __fastcall TForm1::About1Click(TObject *Sender)
{
   AboutBox->ShowModal();	
}
//---------------------------------------------------------------------------
